local waitTable = {};
local waitFrame = nil;

-- local variables
local CLEANUI_HOOKED = nil;
local init = false;

local active = true;

local actStatusBarTexture = nil;

local actionButtonFrames = {};

-- spells
local SURGING_MIST, CHI_HEAL, ENVELOPING_MIST, SOOTHING_MIST, RENEWING_MIST, UPLIFT, REVIVAL, LIFE_COCOON, MANATEA, THUNDERFOCUSTEA, CHIBREW, DETOX;
local SURGING_MIST_ID, CHI_HEAL_ID, ENVELOPING_MIST_ID, SOOTHING_MIST_ID, RENEWING_MIST_ID, UPLIFT_ID, REVIVAL_ID, LIFE_COCOON_ID, MANATEA_ID, THUNDERFOCUSTEA_ID, CHIBREW_ID, DETOX_ID;


------The default setup function
local texCoords = {
    ["Raid-AggroFrame"] = {  0.00781250, 0.55468750, 0.00781250, 0.27343750 },
    ["Raid-TargetFrame"] = { 0.00781250, 0.55468750, 0.28906250, 0.55468750 },
}

local debug = true;
function mw_debug(value, name)
    if (not debug) then
        return;
    end

    if (name) then
        DEFAULT_CHAT_FRAME:AddMessage("debug "..name..": "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    else
        DEFAULT_CHAT_FRAME:AddMessage("debug: "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    end
end

function mw_info(message)
    if (message) then
        DEFAULT_CHAT_FRAME:AddMessage(message, 1.0, 1.0, 1.0, 1, 10);
    end
end

function mw_rgb2hex(red, green, blue)

    if (not red) then
        red = 1.0;
    end

    if (not green) then
        green = 1.0;
    end

    if (not blue) then
        blue = 1.0;
    end

    local r = string.format("%x", red * 255);
    local g = string.format("%x", green * 255);
    local b = string.format("%x", blue * 255);
    
    if (strlen(r) < 2) then
        r = "0"..r;
    end
    if (strlen(g) < 2) then
        g = "0"..g;
    end
    if (strlen(b) < 2) then
        b = "0"..b;
    end
    
    local color = r..g..b;
    
    return color;
end

-- functions
function MistWeaver_OnLoad(self)

 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffNirriti's|r MistWeaver loaded.", 1.0, 1.0, 1.0, 1, 10);

 	self:RegisterEvent("ADDON_LOADED");
 	
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    self:RegisterEvent("PLAYER_REGEN_ENABLED");
    
    self:RegisterEvent("PLAYER_ROLES_ASSIGNED");
    
    self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
    self:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
    
    self:RegisterEvent("GROUP_ROSTER_UPDATE");
    
    self:RegisterEvent("UNIT_HEALTH");
    self:RegisterEvent("UNIT_MAXHEALTH");
    self:RegisterEvent("UNIT_HEAL_PREDICTION");

	SLASH_MISTWEAVER1 = "/mw";
    SLASH_MISTWEAVER2 = "/mistweaver";
  	SlashCmdList["MISTWEAVER"] = function(msg)
		MistWeaver_SlashCommandHandler(msg);
	end
end

function MistWeaver_OnEvent(self, event, ...)    
	if (event == "ADDON_LOADED") then	
		local addonName = ...;
        if (addonName == "MistWeaver") then
            MistWeaver_StartDelay(3, MistWeaver_Init);
        end
	end  
	
    if (event == "PLAYER_ENTERING_WORLD") then
        MistWeaver_HookCleanUI();
    end 
    
    if (not init) then
       return;
    end
    
    if (event == "PLAYER_REGEN_ENABLED" or event == "GROUP_ROSTER_UPDATE") then
        MistWeaver_RebindUnitFrames();
    end
    if (event == "PARTY_MEMBERS_CHANGED") then
        MistWeaver_PartyMembersChanged();
    end
    if (event == "ACTIVE_TALENT_GROUP_CHANGED") then
        MistWeaver_StartDelay(5, MistWeaver_Init);
    end
    if (event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "UPDATE_SHAPESHIFT_FORM") then
        MistWeaver_UpdateActiveState();
    end
    if (event == "PLAYER_ROLES_ASSIGNED") then
        MistWeaver_PlayerRolesAssigned();
    end
    if (event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" or event == "UNIT_HEAL_PREDICTION") then
        MistWeaver_UpdateHealPrediction(self);
    end
end

function MistWeaver_StartDelay(delay, func, ...)
    if(type(delay)~="number" or type(func)~="function") then
        return false;
    end
    
    if(waitFrame == nil) then
        waitFrame = MistWeaver_CreateFrame("Frame","MW_WaitFrame", UIParent);
        waitFrame:SetScript("onUpdate",function (self,elapse)
            local count = #waitTable;
            local i = 1;
            
            while(i<=count) do
                local waitRecord = tremove(waitTable,i);
                local d = tremove(waitRecord,1);
                local f = tremove(waitRecord,1);
                local p = tremove(waitRecord,1);
                
                if(d>elapse) then
                    tinsert(waitTable,i,{d-elapse,f,p});
                    i = i + 1;
                else
                    count = count - 1;
                    f(unpack(p));
                end
            end
        end);
    end
    
    tinsert(waitTable,{delay,func,{...}});
    
    return true;
end

function MistWeaver_HookCleanUI()
    if (CLEANUI_HOOKED or not IsAddOnLoaded("CleanUI")) then
        return;
    end
    
    hooksecurefunc("CleanUI_HookChangeStatusBar", MistWeaver_ChangeStatusBar); 
    
    CLEANUI_HOOKED = 1;
end

function MistWeaver_ChangeStatusBar(texture)
    actStatusBarTexture = texture;
    MistWeaver_ReloadStatusBarTexture();
end

function MistWeaver_ReloadStatusBarTexture()

    local healthBar, healthPredictionBar, renewingMistBar; 
    
    for i=1, 25, 1 do
        healthBar = _G["MwUnitFrame"..i.."Health"];
        if (not healthBar) then
            MistWeaver_StartDelay(3, MistWeaver_ReloadStatusBarTexture);
            return;
        end
    end
    
    local texture = actStatusBarTexture;
    
    for i=1, 25, 1 do
        healthBar = _G["MwUnitFrame"..i.."Health"];
        healthBar:SetStatusBarTexture(texture);
        healthPredictionBar = _G["MwUnitFrame"..i.."HealthPrediction"];
        healthPredictionBar:SetStatusBarTexture(texture);
        renewingMistBar = _G["MwUnitFrame"..i.."RenewingMist"];
        renewingMistBar:SetStatusBarTexture(texture);
    end
    
    MwPowerFrameChi:SetStatusBarTexture(texture);
    MwPowerFrameMana:SetStatusBarTexture(texture);
end

function MistWeaver_SlashCommandHandler(msg)
	if (msg == "reload") then
	 	ReloadUI();
    elseif (string.find(msg, "help") == 1) then
        MistWeaver_Help();
    elseif (string.find(msg, "on") == 1) then
        MistWeaverData.ACTIVE = 1;
        MistWeaver_UpdateActiveState();
    elseif (string.find(msg, "off") == 1) then
        MistWeaverData.ACTIVE = 0;
        MistWeaver_UpdateActiveState();
    elseif (string.find(msg, "width") == 1) then
        local str_width = string.sub(msg, 7);
        local width = tonumber(str_width);
        
        if (width and width >= 50 and width <= 200) then
            MistWeaverData.UNITWIDTH = width;
            MistWeaver_UpdateUnitFrameSize();
        else
            mw_info("|c333399ffwidth|r: 50 - 200");
        end
    elseif (string.find(msg, "height") == 1) then
        local str_height = string.sub(msg, 8);
        local height = tonumber(str_height);
        
        if (height and height >= 40 and height <= 100) then
            MistWeaverData.UNITHEIGHT = height;
            MistWeaver_UpdateUnitFrameSize();
        else
            mw_info("|c333399ffheight|r: 40 - 100");
        end
    elseif (string.find(msg, "colortype") == 1) then
        local colortype = string.sub(msg, 11);
        
        if (colortype == "health") then
            MistWeaverData.COLORTYPE = 1;
        elseif (colortype == "class") then
            MistWeaverData.COLORTYPE = 2;
        else
            mw_info("|c333399ffcolortype|r health "..MW_OR_INSET.." class");
        end
    elseif (string.find(msg, "sorttype") == 1) then
        local sorttype = string.sub(msg, 10);
        
        if (sorttype == "id") then
            MistWeaverData.SORTTYPE = 1;
        elseif (sorttype == "group") then
            MistWeaverData.SORTTYPE = 2;
        elseif (sorttype == "name") then
            MistWeaverData.SORTTYPE = 3;
        else
            mw_info("|c333399ffsorttype|r id, group "..MW_OR_INSET.." name");
        end
    
        MistWeaver_RebindUnitFrames();
    elseif (msg == "test") then
        local charges, maxCharges, chargeStart, chargeDuration = GetSpellCharges(116740);
        mw_debug(charges, "charges");
        mw_debug(maxCharges, "maxCharges");
        mw_debug(chargeStart, "chargeStart");
        mw_debug(chargeDuration, "chargeDuration");
        
        local charges, maxCharges, chargeStart, chargeDuration = GetSpellCharges(56, SpellBookFrame.bookType);
        mw_debug(charges, "charges");
        mw_debug(maxCharges, "maxCharges");
        mw_debug(chargeStart, "chargeStart");
        mw_debug(chargeDuration, "chargeDuration");
        
        local charges, maxCharges, chargeStart, chargeDuration = GetActionCharges(59);
        mw_debug(charges, "charges");
        mw_debug(maxCharges, "maxCharges");
        mw_debug(chargeStart, "chargeStart");
        mw_debug(chargeDuration, "chargeDuration");
    end
    
    MwConfig_RefreshUI();
end

function MistWeaver_Help()
    mw_info("|c333399ffNirriti's|r MistWeaver "..MW_HELP..":");
    
    mw_info("|c333399ff  - ["..CTRL_KEY.."] + "..KEY_BUTTON2.."|r "..MW_MOVE_FRAME);
    
    mw_info("|c333399ff  - "..MW_CLICK_CHIBAR.."|r "..MW_USE_CHIBREW);
    
    mw_info("|c333399ff  - "..MW_CHATCOMMAND.."|r /mw "..MW_OR_INSET.." /mistweaver");
    mw_info("|c333399ff      /mw width #|r "..MW_UNIT_FRAME_WIDTH.." (50 - 200)");
    mw_info("|c333399ff      /mw height #|r "..MW_UNIT_FRAME_HEIGHT.." (40 - 100)");
    mw_info("|c333399ff      /mw colortype health|r "..MW_UNIT_SELECT_HEALTH);
    mw_info("|c333399ff      /mw colortype class|r "..MW_UNIT_SELECT_CLASS);
    mw_info("|c333399ff      /mw sorttype id|r "..MW_UNIT_SELECT_ID);
    mw_info("|c333399ff      /mw sorttype group|r "..MW_UNIT_SELECT_GROUP);
    mw_info("|c333399ff      /mw sorttype name|r "..MW_UNIT_SELECT_NAME);
    mw_info("|c333399ff      /mw on|r "..MW_ON);
    mw_info("|c333399ff      /mw off|r "..MW_OFF);
    
    mw_info("|c333399ff  - "..MW_UNIT_FRAMES);
    mw_info("|c333399ff      ["..ALT_KEY.."]+mouse over:|r "..MW_SHOW_TOOLTIP);
    mw_info("|c333399ff      ["..CTRL_KEY.."]+"..KEY_BUTTON1..":|r "..MW_SHOW_OOR);
    mw_info("|c333399ff      ["..CTRL_KEY.."]+"..KEY_BUTTON2..":|r "..MW_SHOW_HIGHLIGHT);
        
    mw_info("|c333399ff  - "..MW_HEALTH_BAR_SPELLS);
    MistWeaver_ShowButtonInfo(_G["MwUnitFrame1Button1"]);
    mw_info("|c333399ff  - "..MW_RENEWING_MIST_SPELLS);
    MistWeaver_ShowButtonInfo(_G["MwUnitFrame1Button2"]);
end

function MistWeaver_ShowButtonInfo(button)
    local spell1 = button:GetAttribute("spell1");
    local spell2 = button:GetAttribute("spell2");
    local spell3 = button:GetAttribute("spell3");
    local shift_spell1 = button:GetAttribute("shift-spell1");
    local shift_spell2 = button:GetAttribute("shift-spell2");
    local alt_spell1 = button:GetAttribute("alt-spell1");
    local alt_spell2 = button:GetAttribute("alt-spell2");
    
    if (shift_spell1 == spell1) then
        shift_spell1 = nil;
    end
    if (shift_spell2 == spell2) then
        shift_spell2 = nil;
    end
    
    if (spell1) then
        mw_info("|c333399ff      "..KEY_BUTTON1..":|r "..spell1);  
    end
    if (spell2) then
        mw_info("|c333399ff      "..KEY_BUTTON2..":|r "..spell2);   
    end
    if (spell3) then
        mw_info("|c333399ff      "..KEY_BUTTON3..":|r "..spell3);   
    end
    if (shift_spell1) then
        mw_info("|c333399ff      ".."["..SHIFT_KEY.."] + "..KEY_BUTTON1..":|r "..shift_spell1);  
    end 
    if (shift_spell2) then
        mw_info("|c333399ff      ".."["..SHIFT_KEY.."] + "..KEY_BUTTON2..":|r "..shift_spell2);  
    end    
    if (alt_spell1) then
        mw_info("|c333399ff      ".."["..ALT_KEY.."] + "..KEY_BUTTON1..":|r "..alt_spell1);  
    end 
    if (alt_spell2) then
        mw_info("|c333399ff      ".."["..ALT_KEY.."] + "..KEY_BUTTON2..":|r "..alt_spell2);  
    end          
end

function MistWeaver_UpdateActiveState()

    if (InCombatLockdown()) then
        return;
    end
    
    -- monk only
    local _, unitClass = UnitClass("player");
    
    -- all or serpent stance only    
    local icon1 = GetShapeshiftFormInfo(1);
    local icon2 = GetShapeshiftFormInfo(2);
    
    local serpentStance = 1;
    if (icon1 and string.find(icon1, "wiseserpent")) then
        serpentStance = 1;
    elseif (icon2 and string.find(icon2, "wiseserpent")) then
        serpentStance = 2;
    end
    
    local shapeshiftOk = MistWeaverData.SHOW_IN_ALL_STANCES == 1 or GetShapeshiftForm() == serpentStance;
    
    local activeSpecGroup = GetActiveSpecGroup();
    local specialization = GetSpecialization(_, _, activeSpecGroup);
    local specializationOk = specialization == 2;
    local groupOk = MistWeaverData.SHOW_SOLO == 1 or GetNumGroupMembers() > 0;

    if (unitClass == "MONK" and shapeshiftOk and specializationOk and groupOk and MistWeaverData.ACTIVE == 1) then
        MistWeaverFrame:Show();
        active = true;
    else
        MistWeaverFrame:Hide();
        active = false;
    end
end

function MistWeaver_SetBackdrop(frame)

    local background = "Interface\\Addons\\MistWeaver\\images\\frame-background";
    local border = "Interface\\Addons\\MistWeaver\\images\\frame-border";
    
    if (CleanUIData) then
        background = CleanUIData.CUI_FRAME_BACKGROUND or "Interface\\Addons\\MistWeaver\\images\\frame-background";
        border = CleanUIData.CUI_FRAME_BORDER or "Interface\\Addons\\MistWeaver\\images\\frame-border";
    end

    frame:SetBackdrop( { 
            bgFile = background, 
            edgeFile = border, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    frame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
end

function MistWeaver_MwPowerFrameOnMouseDown(frame, button)
    if (button == "RightButton") then
        if (IsControlKeyDown()) then
            MistWeaverFrame:StartMoving();
        end
    end
end

function MistWeaver_MwPowerFrameOnMouseUp(frame, button)
    MistWeaverFrame:StopMovingOrSizing();
end

function MistWeaver_LoadSpells()

    SURGING_MIST_ID = 116694;
    SURGING_MIST = GetSpellInfo(SURGING_MIST_ID);
    
    local chiWave = GetSpellInfo(115098);
    local zenSphere = GetSpellInfo(124081);
    local chiBurst = GetSpellInfo(123986);
    
    CHI_HEAL_ID = nil;
    CHI_HEAL = nil;
    if (GetSpellInfo(chiWave)) then
        CHI_HEAL_ID = 115098;
        CHI_HEAL = chiWave;
    elseif (GetSpellInfo(zenSphere)) then
        CHI_HEAL_ID = 124081;
        CHI_HEAL = zenSphere;
    elseif (GetSpellInfo(chiBurst)) then
        CHI_HEAL_ID = 123986;
        CHI_HEAL = chiBurst;
    end
    
    ENVELOPING_MIST_ID = 124682;
    ENVELOPING_MIST = GetSpellInfo(ENVELOPING_MIST_ID);
    SOOTHING_MIST_ID = 115175;
    SOOTHING_MIST = GetSpellInfo(SOOTHING_MIST_ID);
    RENEWING_MIST_ID = 115151;
    RENEWING_MIST = GetSpellInfo(RENEWING_MIST_ID);
    
    UPLIFT_ID = 116670;   
    UPLIFT = GetSpellInfo(UPLIFT_ID);    
    
    REVIVAL_ID = 115310;  
    REVIVAL = GetSpellInfo(REVIVAL_ID);    
    LIFE_COCOON_ID = 116849;
    LIFE_COCOON = GetSpellInfo(LIFE_COCOON_ID);
    
    MANATEA_ID = 115294;
    MANATEA = GetSpellInfo(MANATEA_ID);
    THUNDERFOCUSTEA_ID = 116680;
    THUNDERFOCUSTEA = GetSpellInfo(THUNDERFOCUSTEA_ID);
    CHIBREW_ID = 115399;
    CHIBREW = GetSpellInfo(CHIBREW_ID);
    
    DETOX_ID = 115450;
    DETOX = GetSpellInfo(DETOX_ID);
end

function MistWeaver_OnButtonEvent(self, event, ...)
    if ( event == "ACTIONBAR_UPDATE_COOLDOWN") then   
    
        local spell = self:GetAttribute("spell");
        
        if (GetSpellInfo(spell)) then
            local cooldown = _G[self:GetName().."Cooldown"];
         
            local start, duration, enable = GetSpellCooldown(spell);
        
            if (cooldown and start and duration and enable) then
                CooldownFrame_SetTimer(cooldown, start, duration, enable);
            end
        end
    end
end

function MistWeaver_OnButtonUpdate(self, elapsed)
    if (not active) then
        return;
    end

    local texture = self.icon;

    local spell = self:GetAttribute("spell");
    local usable, nomana = IsUsableSpell(spell);
    
    if (usable) then
        texture:SetVertexColor(1.0, 1.0, 1.0);
    elseif (nomana) then
        texture:SetVertexColor(0.5, 0.5, 1.0);
    else
        texture:SetVertexColor(0.4, 0.4, 0.4);
    end
end

function MistWeaver_OnButtonEnter(self)   
    local spell = self:GetAttribute("spell");
    local spellId = self:GetAttribute("spellId");
    
    if (not spellId) then
        return;
    end
    
    GameTooltip_SetDefaultAnchor(GameTooltip, self);     
    GameTooltip:SetSpellByID(spellId);                   
    GameTooltip:Show();
end

function MistWeaver_OnButtonLeave(self)
    GameTooltip:FadeOut();
end

function MistWeaver_OnUnitFrameEnter(self)
    local unitFrame = self.unitFrame;
    
    unitFrame.art.hover:Show();

    if (IsAltKeyDown()) then
        MistWeaver_ShowUnitFrameTooltip(self);
    end
end

function MistWeaver_ChiBrewOnUpdate(self, elapsed)
    if (not active) then
        return;
    end

    local texture = self.icon;

    local spell = self:GetAttribute("spell");
    local usable, nomana = IsUsableSpell(spell);
    local start, duration, enable = GetSpellCooldown(spell);
    
    if (not start) then
        start = 0;
    end
    if (not duration) then
        duration = 0;
    end
    
    if (start > 0 and duration > 0) then
        MwPowerFrameChi.text:SetTextColor(1.0, 1.0, 1.0); -- has cooldown -> not usable
    elseif (usable) then
        MwPowerFrameChi.text:SetTextColor(0.0, 1.0, 0.0); -- usable
    elseif (nomana) then
        MwPowerFrameChi.text:SetTextColor(1.0, 1.0, 1.0); -- not usable
    else
        MwPowerFrameChi.text:SetTextColor(1.0, 1.0, 1.0); -- not usable
    end
end

function MistWeaver_ShowUnitFrameTooltip(self)   
    local spell1 = self:GetAttribute("spell1");
    local spell2 = self:GetAttribute("spell2");
    local spell3 = self:GetAttribute("spell3");
    local shift_spell1 = self:GetAttribute("shift-spell1");
    local shift_spell2 = self:GetAttribute("shift-spell2");
    local alt_spell1 = self:GetAttribute("alt-spell1");
    local alt_spell2 = self:GetAttribute("alt-spell2");
    
    if (shift_spell1 == spell1) then
        shift_spell1 = nil;
    end
    if (shift_spell2 == spell2) then
        shift_spell2 = nil;
    end
    
    GameTooltip_SetDefaultAnchor(GameTooltip, self);
    
    GameTooltip:AddLine(MW_SPELLS..":", 1.0, 1.0, 1.0);   
    
    GameTooltip:AddLine(" ", 1.0, 1.0, 1.0);  
        
    if (spell1) then
        GameTooltip:AddDoubleLine("|c333399ff"..KEY_BUTTON1.."|r", spell1, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);  
    end
    if (spell2) then
        GameTooltip:AddDoubleLine("|c333399ff"..KEY_BUTTON2.."|r", spell2, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);   
    end
    if (spell3) then
        GameTooltip:AddDoubleLine("|c333399ff"..KEY_BUTTON3.."|r", spell3, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);   
    end
    if (shift_spell1) then
        GameTooltip:AddDoubleLine("|c333399ff".."["..SHIFT_KEY.."] + "..KEY_BUTTON1.."|r", shift_spell1, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);  
    end 
    if (shift_spell2) then
        GameTooltip:AddDoubleLine("|c333399ff".."["..SHIFT_KEY.."] + "..KEY_BUTTON2.."|r", shift_spell2, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);  
    end 
    if (alt_spell1) then
        GameTooltip:AddDoubleLine("|c333399ff".."["..ALT_KEY.."] + "..KEY_BUTTON1.."|r", alt_spell1, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);  
    end 
    if (alt_spell2) then
        GameTooltip:AddDoubleLine("|c333399ff".."["..ALT_KEY.."] + "..KEY_BUTTON2.."|r", alt_spell2, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);  
    end          
    
    GameTooltip:AddLine(" ", 1.0, 1.0, 1.0);  
  
    GameTooltip:AddDoubleLine("|c333399ff".."["..CTRL_KEY.."] + "..KEY_BUTTON1.."|r", MW_SHOW_OOR, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0); 
    GameTooltip:AddDoubleLine("|c333399ff".."["..CTRL_KEY.."] + "..KEY_BUTTON2.."|r", MW_SHOW_HIGHLIGHT, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);    
    
    GameTooltip:Show();
end

function MistWeaver_OnUnitFrameLeave(self)
    local unitFrame = self.unitFrame;
    
    unitFrame.art.hover:Hide();
    
    GameTooltip:FadeOut();
end

function MistWeaver_Init()

    MistWeaver_UpdateActiveState();

    local _, unitClass = UnitClass("player");
    if (unitClass ~= "MONK") then
        return;
    end

    MistWeaver_CreateUnitFrames();
    MistWeaver_LoadSpells();

    local powerFrame = _G["MwPowerFrame"];
    MistWeaver_SetBackdrop(powerFrame);
    
    local chiBar = MistWeaver_CreateFrame("StatusBar", "MwPowerFrameChi", powerFrame, "MwTextStatusBarTemplate");
    chiBar:ClearAllPoints();
    chiBar:SetPoint("TOPLEFT", powerFrame, "TOPLEFT", 4, -4);
    chiBar:SetPoint("BOTTOMRIGHT", powerFrame, "BOTTOMRIGHT", -4, 16);
    chiBar:SetStatusBarColor(0.85, 0.85, 0.85);
    chiBar:SetFrameStrata("HIGH");
    
    -- chi brew
    local chiBrew = MistWeaver_CreateFrame("Button", "MwUnitFrameChiBrew", chiBar, "SecureActionButtonTemplate");
    chiBrew:SetFrameStrata("HIGH");
    chiBrew:ClearAllPoints();
    chiBrew:SetPoint("TOPLEFT", chiBar, "TOPLEFT", 0, 0);
    chiBrew:SetPoint("BOTTOMRIGHT", chiBar, "BOTTOMRIGHT", 0, 0);
    chiBrew:RegisterForClicks("AnyUp");
    chiBrew:SetAttribute("type", "spell");
    chiBrew:SetAttribute("spell", CHIBREW);
    chiBrew:SetAttribute("spellId", CHIBREW_ID);
    chiBrew:HookScript("OnUpdate", MistWeaver_ChiBrewOnUpdate);
    chiBrew:HookScript("OnEnter", MistWeaver_OnButtonEnter);
    chiBrew:HookScript("OnLeave", MistWeaver_OnButtonLeave);
        
    local manaBar = MistWeaver_CreateFrame("StatusBar", "MwPowerFrameMana", powerFrame, "MwTextStatusBarTemplate");
    manaBar:ClearAllPoints();
    manaBar:SetPoint("TOPLEFT", chiBar, "BOTTOMLEFT", 0, 0);
    manaBar:SetPoint("BOTTOMRIGHT", powerFrame, "BOTTOMRIGHT", -4, 4);
    local manacolor = PowerBarColor["MANA"];
    manaBar:SetStatusBarColor(manacolor.r, manacolor.g, manacolor.b);
    manaBar:SetFrameStrata("HIGH");
    
    -- AE
    local revivalCast = MistWeaver_CreateActionButton("MwRevivalCastFrame", REVIVAL, REVIVAL_ID, 70);
    revivalCast:SetPoint("TOPRIGHT", powerFrame, "TOPLEFT", 0, 0);
    
    -- left/right
    local envelopingMistCast = MistWeaver_CreateActionButton("MwEnvelopingMistCastFrame", ENVELOPING_MIST, ENVELOPING_MIST_ID, 36);
    envelopingMistCast:SetPoint("TOPLEFT", revivalCast, "BOTTOMLEFT", 0, -4);
    
    local soothingMistCast = MistWeaver_CreateActionButton("MwSoothingMistCastFrame", SOOTHING_MIST, SOOTHING_MIST_ID, 36);
    soothingMistCast:SetPoint("TOPLEFT", envelopingMistCast, "TOPRIGHT", -2, 0);
    
    -- shift left/right
    local surgingMistCast = MistWeaver_CreateActionButton("MwSurgingMistCastFrame", SURGING_MIST, SURGING_MIST_ID, 36);
    surgingMistCast:SetPoint("TOPLEFT", envelopingMistCast, "BOTTOMLEFT", 0, 2);   
    
    local chiHealCast = MistWeaver_CreateActionButton("MwChiHealCastFrame", CHI_HEAL, CHI_HEAL_ID, 36);
    chiHealCast:SetPoint("TOPLEFT", surgingMistCast, "TOPRIGHT", -2, 0);
    
    -- middle
    local lifeCocoonCast = MistWeaver_CreateActionButton("MwLifeCocoonCastFrame", LIFE_COCOON, LIFE_COCOON_ID, 70);
    lifeCocoonCast:SetPoint("TOPLEFT", surgingMistCast, "BOTTOMLEFT", 0, -3);
    
    -- left/right
    local upliftCast = MistWeaver_CreateActionButton("MwUpliftCastFrame", UPLIFT, UPLIFT_ID, 36);
    upliftCast:SetPoint("TOPLEFT", lifeCocoonCast, "BOTTOMLEFT", 0, -3);
    
    local renewingMistCast = MistWeaver_CreateActionButton("MwRenewingMistCastFrame", RENEWING_MIST, RENEWING_MIST_ID, 36);
    renewingMistCast:SetPoint("TOPLEFT", upliftCast, "TOPRIGHT", -2, 0);
    
    -- mana tea
    local manaTea = MistWeaver_CreateActionButton("MwManaTeaFrame", MANATEA, MANATEA_ID, 42);
    manaTea:SetPoint("TOPLEFT", powerFrame, "TOPRIGHT", 1, 0);
    
    -- thunder focus tea
    local thunderFocusTea = MistWeaver_CreateActionButton("MwThunderFocusTeaFrame", THUNDERFOCUSTEA, THUNDERFOCUSTEA_ID, 42);
    thunderFocusTea:SetPoint("TOPLEFT", manaTea, "TOPRIGHT", -2, 0);
    
    local unitFrame, backdrop, healthBar, renewingMistBar, button1, button2, art;
    
    _, _, detox_icon = GetSpellInfo(DETOX_ID);
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        
        backdrop = MistWeaver_CreateFrame("Frame", "MwUnitFrame"..i.."Backdrop", unitFrame);
        backdrop:ClearAllPoints();
        backdrop:SetAllPoints(unitFrame);
        MistWeaver_SetBackdrop(backdrop);
        
        unitFrame:SetFrameStrata("BACKGROUND");
        
        healthBar = MistWeaver_CreateFrame("StatusBar", "MwUnitFrame"..i.."Health", unitFrame, "MwTextStatusBarTemplate");
        healthBar:ClearAllPoints();
        healthBar:SetPoint("TOPLEFT", unitFrame, "TOPLEFT", 4, -4);
        healthBar:SetPoint("BOTTOMRIGHT", unitFrame, "BOTTOMRIGHT", -4, 20);
        healthBar:SetStatusBarColor(0.0, 1.0, 0.0);
        healthBar:SetFrameStrata("LOW");
        
        healthPredictionBar = MistWeaver_CreateFrame("StatusBar", "MwUnitFrame"..i.."HealthPrediction", unitFrame, "MwTextStatusBarTemplate");
        healthPredictionBar:ClearAllPoints();
        healthPredictionBar:SetAllPoints(healthBar);    
        healthPredictionBar:SetAlpha(0.5);
        healthPredictionBar:SetStatusBarColor(0.3, 1.0, 0.7);
        healthPredictionBar:SetFrameStrata("BACKGROUND");        
        healthPredictionBar:SetMinMaxValues(0, 100);
        healthPredictionBar:SetValue(0);
    
        renewingMistBar = MistWeaver_CreateFrame("StatusBar", "MwUnitFrame"..i.."RenewingMist", unitFrame, "MwTextStatusBarTemplate");
        renewingMistBar:ClearAllPoints();
        renewingMistBar:SetPoint("TOPLEFT", healthBar, "BOTTOMLEFT", 0, 0);
        renewingMistBar:SetPoint("BOTTOMRIGHT", unitFrame, "BOTTOMRIGHT", -4, 4);
        renewingMistBar:SetStatusBarColor(0.0, 0.7, 0.7);
        renewingMistBar:SetFrameStrata("LOW");
        
        art = MistWeaver_CreateFrame("Frame", "MwUnitFrame"..i.."Art", unitFrame, "MwUnitArtFrameTemplate");
        art:ClearAllPoints();
        art:SetPoint("TOPLEFT", unitFrame, "TOPLEFT", 2, -2);
        art:SetPoint("BOTTOMRIGHT", unitFrame, "BOTTOMRIGHT", -2, 2);
        art.aggro:SetTexCoord(unpack(texCoords["Raid-AggroFrame"]));        
        art.info:SetTextColor(1.0, 0.0, 0.0);
        art.highlight:SetVertexColor(MistWeaverData.HIGHLIGHT_RED, MistWeaverData.HIGHLIGHT_GREEN, MistWeaverData.HIGHLIGHT_BLUE);        
        unitFrame.art = art;        
        unitFrame.art.detox:SetTexture(detox_icon);
        
        -- action buttons
        button1 = MistWeaver_CreateFrame("Button", "MwUnitFrame"..i.."Button1", unitFrame, "SecureActionButtonTemplate");
        button1:SetFrameStrata("HIGH");
        button1:ClearAllPoints();
        button1:SetPoint("TOPLEFT", healthBar, "TOPLEFT", 0, 0);
        button1:SetPoint("BOTTOMRIGHT", healthBar, "BOTTOMRIGHT", 0, 0);
        button1:RegisterForClicks("AnyUp");
        button1:HookScript("OnEnter", MistWeaver_OnUnitFrameEnter);
        button1:HookScript("OnLeave", MistWeaver_OnUnitFrameLeave);
        button1.unitFrame = unitFrame;
        
        button2 = MistWeaver_CreateFrame("Button", "MwUnitFrame"..i.."Button2", unitFrame, "SecureActionButtonTemplate");
        button2:SetFrameStrata("HIGH");
        button2:ClearAllPoints();
        button2:SetPoint("TOPLEFT", renewingMistBar, "TOPLEFT", 0, 0);
        button2:SetPoint("BOTTOMRIGHT", renewingMistBar, "BOTTOMRIGHT", 0, 0);
        button2:RegisterForClicks("AnyUp");
        button2:HookScript("OnEnter", MistWeaver_OnUnitFrameEnter);
        button2:HookScript("OnLeave", MistWeaver_OnUnitFrameLeave);
        button2.unitFrame = unitFrame;
    end
    
    MistWeaver_UpdateUnitFrameSize();
    
    init = true;
    
    -- events
    MistWeaver_RebindUnitFrames();
    MistWeaver_PartyMembersChanged();
    MistWeaver_UpdateActiveState();
    MistWeaver_PlayerRolesAssigned();
end

function MistWeaver_CreateActionButton(name, spell, spellId, size)
    local frame = MistWeaver_CreateFrame("Frame", name, MistWeaverFrame, "MistWeaverButtonFrameTemplate");
    frame:SetParent(MistWeaverFrame);
    frame:SetSize(size, size);
    frame.button:RegisterForClicks("AnyUp");
    frame.button:SetAttribute("type", "spell");
    frame.button:SetAttribute("spell", spell);
    frame.button:SetAttribute("spellId", spellId);
    
    local _, _, texture = GetSpellInfo(spell);
    
    frame.button.icon:SetTexture(texture);
    frame.button.icon:SetTexCoord(0.1, 0.9, 0.1, 0.9);
    frame.button.icon:SetDrawLayer("BORDER");
    
    if (not texture) then
        frame:SetAlpha(0.5);
    else
        frame:SetAlpha(1.0);
    end
    
    frame.button:HookScript("OnUpdate", MistWeaver_OnButtonUpdate);
    frame.button:HookScript("OnEnter", MistWeaver_OnButtonEnter);
    frame.button:HookScript("OnLeave", MistWeaver_OnButtonLeave);
            
    frame.button:GetPushedTexture():ClearAllPoints();
    frame.button:GetPushedTexture():SetPoint("TOPLEFT", frame.button, "TOPLEFT", 2, -2); 
    frame.button:GetPushedTexture():SetPoint("BOTTOMRIGHT", frame.button, "BOTTOMRIGHT", -2, 2);  
    frame.button:GetPushedTexture():SetDrawLayer("OVERLAY"); 
            
    frame.button:GetHighlightTexture():ClearAllPoints();
    frame.button:GetHighlightTexture():SetPoint("TOPLEFT", frame.button, "TOPLEFT", -1, 1); 
    frame.button:GetHighlightTexture():SetPoint("BOTTOMRIGHT", frame.button, "BOTTOMRIGHT", 1, -1);
    
    tinsert(actionButtonFrames, name);
    
    return frame;
end

function MistWeaver_CreateUnitFrames()
    local unitFrame;
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        if (not unitFrame) then
            unitFrame = CreateFrame("Frame", "MwUnitFrame"..i, MistWeaverFrame, MwUnitFrameTemplate);
        end
    end
    
    MistWeaver_SetupUnitFramePositions();
end

function MistWeaver_SetupUnitFramePositions()
    if (InCombatLockdown()) then
        return;
    end
    
    if (MistWeaverData.ORIENTATION == 1) then
        MistWeaver_SetupUnitFramesVertical();
    elseif (MistWeaverData.ORIENTATION == 2) then
        MistWeaver_SetupUnitFramesHorizontal();
    end
end

function MistWeaver_SetupUnitFramesVertical()
    local unitFrame, relativeTo, realtivePoint, x, y, pos, firstInGroup;
    
    relativeTo = MistWeaverFrame;
    realtivePoint = "TOPLEFT";
    x = 0;
    y = 0;
    
    for i=1, 25, 1 do
        pos = mod(i,5);
        unitFrame = _G["MwUnitFrame"..i];
        
        if (relativeTo == MistWeaverFrame) then
            realtivePoint = "TOPLEFT";
            x = 0;
            y = 0;
        elseif (pos == 1) then
            relativeTo = firstInGroup;
            realtivePoint = "TOPRIGHT";
            x = -2;
            y = 0;
        else
            realtivePoint = "BOTTOMLEFT";
            x = 0;
            y = 2;
        end
        
        if (pos == 1) then
            firstInGroup = unitFrame;
        end
        
        unitFrame:ClearAllPoints();
        unitFrame:SetPoint("TOPLEFT", relativeTo, realtivePoint, x, y); 
        
        relativeTo = unitFrame;
    end
end

function MistWeaver_SetupUnitFramesHorizontal()
    local unitFrame, relativeTo, realtivePoint, x, y, pos, firstInGroup;
    
    relativeTo = MistWeaverFrame;
    realtivePoint = "TOPLEFT";
    x = 0;
    y = 0;
    
    for i=1, 25, 1 do
        pos = mod(i,5);
        unitFrame = _G["MwUnitFrame"..i];
        
        if (relativeTo == MistWeaverFrame) then
            realtivePoint = "TOPLEFT";
            x = 0;
            y = 0;
        elseif (pos == 1) then
            relativeTo = firstInGroup;
            realtivePoint = "BOTTOMLEFT";
            x = 0;
            y = 2;
        else
            realtivePoint = "TOPRIGHT";
            x = -2;
            y = 0;
        end
        
        if (pos == 1) then
            firstInGroup = unitFrame;
        end
        
        unitFrame:ClearAllPoints();
        unitFrame:SetPoint("TOPLEFT", relativeTo, realtivePoint, x, y); 
        
        relativeTo = unitFrame;
    end
end

function MistWeaver_UpdateTextures()
    for index, name in ipairs(actionButtonFrames) do 
        MistWeaver_UpdateTexture(_G[name]);
    end
end

function MistWeaver_CreateFrame(type, name, parent, template)
    local frame = _G[name];
    if (frame) then
        return frame;
    end

    frame = CreateFrame(type, name, parent, template);
    return frame;
end

function MistWeaver_UpdateTexture(frame)
    local spell = frame.button:GetAttribute("spell");
    local _, _, texture = GetSpellInfo(spell);
    frame.button.icon:SetTexture(texture);
end

function MistWeaver_UpdateUnitFrameSize()

    if (InCombatLockdown()) then
        return;
    end
    
    MistWeaver_RebindUnitFrames();
        
    local unitFrame;
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        unitFrame:SetSize(MistWeaverData.UNITWIDTH, MistWeaverData.UNITHEIGHT);
    end
    
    MwPowerFrame:SetWidth(max(MistWeaverData.UNITWIDTH, 100));
end

function MistWeaver_PartyMembersChanged()     
    MistWeaver_RebindUnitFrames();
    MistWeaver_UpdateTextures();
end

function MistWeaver_RebindUnitFrames()

    if (InCombatLockdown()) then
        return;
    end
    
    MistWeaver_UpdateActiveState();    
    
    local unitFrame, subgroup, role;
    if (IsInRaid()) then
        if (MistWeaverData.SORTTYPE == 3) then
            MistWeaver_RebindUnitFramesForRaidByName();
        elseif (MistWeaverData.SORTTYPE == 2) then
            MistWeaver_RebindUnitFramesForRaidByGroup();
        else
            MistWeaver_RebindUnitFramesForRaidById();
        end
    elseif (IsInGroup()) then
        MistWeaver_RebindUnitFramesForGroup();
    else
        MistWeaver_RebindUnitFramesForSolo();
    end
end

function MistWeaver_RebindUnitFramesForSolo()

    local unitFrame, subgroup, role, index, position;
    
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_SetUnit(unitFrame, nil, nil);
    end
    
    MistWeaver_SetUnit(_G["MwUnitFrame1"], "player", nil);
end

function MistWeaver_RebindUnitFramesForRaidByName()

    local name, unitFrame, subgroup, role, index, position;
    
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_SetUnit(unitFrame, nil, nil);
    end
    
    -- create temp table
    local membersByName = {};    
    for i=1, 25, 1 do
        -- name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML
        _, _, _, _, _, _, _, _, _, role, _ = GetRaidRosterInfo(i);
        name = UnitName("raid"..i);
        if (name) then
            membersByName[name] = {index = i, role = role};
        end
    end
    
    index = 1;
    for name,data in pairsByKeys(membersByName) do
        unitFrame = _G["MwUnitFrame"..index];
        MistWeaver_SetUnit(unitFrame, "raid"..data.index, data.role);
        index = index + 1;
    end
end

function pairsByKeys(t, f)
    local a = {};
    
    for n in pairs(t) do
        table.insert(a, n)
    end
    
    table.sort(a, f);
    local i = 0;      -- iterator variable
    local iter = function ()   -- iterator function
        i = i + 1;
        if a[i] == nil then
            return nil;
        else
            return a[i], t[a[i]];
        end
    end
    return iter;
end

function MistWeaver_RebindUnitFramesForRaidByGroup()

    local unitFrame, subgroup, role, index, position;
    
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_SetUnit(unitFrame, nil, nil);
    end
    
    for i=1, 25, 1 do
        -- name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML
        _, _, subgroup, _, _, _, _, _, _, role, _ = GetRaidRosterInfo(i);
        
        index = (subgroup - 1) * 5;
        for g=1, 5, 1 do
            position = index + g;
            unitFrame = _G["MwUnitFrame"..position];
            if (not unitFrame.unit) then
                MistWeaver_SetUnit(unitFrame, "raid"..i, role);
                break;
            end
        end
    end
end

function MistWeaver_RebindUnitFramesForRaidById()

    local unitFrame, role;
    
    for i=1, 25, 1 do
        -- name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML
        _, _, _, _, _, _, _, _, _, role, _ = GetRaidRosterInfo(i);
        
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_SetUnit(unitFrame, "raid"..i, role);
    end
end

function MistWeaver_RebindUnitFramesForGroup()

    local unitFrame;
    
    MistWeaver_SetUnit(_G["MwUnitFrame1"], "player", nil);
    for i = 1, 4 do
        unitFrame = _G["MwUnitFrame"..(i+1)];
        MistWeaver_SetUnit(unitFrame, "party"..i, nil);
    end
    
    -- remove raid
    for i=6, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_SetUnit(unitFrame, nil, nil);
    end
end

function MistWeaver_SetUnit(frame, unit, role)
    if ((not UnitExists(unit)) or unit == nil) then
        frame:Hide();
        frame.unit = nil;
        frame.role = nil;
        
        return;
    end
    
    frame:Show();    
    frame.unit = unit;
    frame.role = role;
    
    MistWeaver_RebindSpells(frame);
end

function MistWeaver_RebindSpells(frame, button1, button2)

    local unit = frame.unit;
    
    local button1 = _G[frame:GetName().."Button1"];
    local button2 = _G[frame:GetName().."Button2"];

    -- set unit
    button1:SetAttribute("unit", unit);
    button2:SetAttribute("unit", unit);
    
    -- no self cast and no focus cast
    button1:SetAttribute("checkselfcast", false);
    button1:SetAttribute("checkfocuscast", false);
    button2:SetAttribute("checkselfcast", false);
    button2:SetAttribute("checkfocuscast", false);    
    
    -- set spells for button 1
    
    button1:SetAttribute("type1", "spell");
    button1:SetAttribute("spell1", ENVELOPING_MIST);
    
    button1:SetAttribute("type2", "spell");
    button1:SetAttribute("spell2", SOOTHING_MIST);
    
    button1:SetAttribute("type3", "spell");
    button1:SetAttribute("spell3", LIFE_COCOON);
    
    button1:SetAttribute("shift-type3", "spell");
    button1:SetAttribute("shift-spell3", LIFE_COCOON);
    
    button1:SetAttribute("shift-type1", "spell");
    button1:SetAttribute("shift-spell1", SURGING_MIST);
    
    button1:SetAttribute("shift-type2", "spell");
    button1:SetAttribute("shift-spell2", CHI_HEAL);
    
    button1:SetAttribute("alt-type1", "spell");
    button1:SetAttribute("alt-spell1", DETOX);
    
    -- set spells for button 2    
    button2:SetAttribute("type1", "spell");
    button2:SetAttribute("spell1", UPLIFT);
    button2:SetAttribute("shift-type1", "spell");
    button2:SetAttribute("shift-spell1", UPLIFT);
    
    button2:SetAttribute("type2", "spell");
    button2:SetAttribute("spell2", RENEWING_MIST);
    button2:SetAttribute("shift-type2", "spell");
    button2:SetAttribute("shift-spell2", RENEWING_MIST);
    
    -- out of range warning und unit markieren       
    button1:SetAttribute("ctrl-type1", "macro");
    button1:SetAttribute("ctrl-macrotext1", "/run MistWeaver_WhisperOutOfRange(\""..frame:GetName().."\")");
    
    button1:SetAttribute("ctrl-type2", "macro");
    button1:SetAttribute("ctrl-macrotext2", "/run MistWeaver_HighlightFrame(\""..frame:GetName().."\")");
    
    button2:SetAttribute("ctrl-type1", "macro");
    button2:SetAttribute("ctrl-macrotext1", "/run MistWeaver_WhisperOutOfRange(\""..frame:GetName().."\")");
    
    button2:SetAttribute("ctrl-type2", "macro");
    button2:SetAttribute("ctrl-macrotext2", "/run MistWeaver_HighlightFrame(\""..frame:GetName().."\")");
end

function MistWeaver_WhisperOutOfRange(framename)
    local frame = _G[framename];
    local unit = frame.unit;
    
    if (unit) then
        local name = UnitName(unit);
        SendChatMessage(MistWeaverData.OUT_OF_RANGE, "WHISPER", nil, name);
    end
end

function MistWeaver_HighlightFrame(framename)
    local frame = _G[framename];
    
    if (frame.highlight) then
        frame.highlight = nil;
    else
        frame.highlight = 1;
    end
end

function MistWeaver_PlayerRolesAssigned()
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        MistWeaver_UpdateRole(unitFrame);
    end
end
    
function MistWeaver_UpdateRole(frame)    
    local role = UnitGroupRolesAssigned(frame.unit);
    local roleIcon = frame.art.roleIcon;
    
    if (roleIcon) then
        if (frame.role == "MAINTANK") then
            roleIcon:SetTexture("Interface\\GroupFrame\\UI-Group-MainTankIcon");
            roleIcon:Show();
            roleIcon:SetSize(10, 10);
        elseif (frame.role == "MAINASSIST") then
            roleIcon:SetTexture("Interface\\GroupFrame\\UI-Group-MainAssistIcon");
            roleIcon:Show();
            roleIcon:SetSize(10, 10);
        elseif (role == "TANK" or role == "HEALER" or role == "DAMAGER") then
            roleIcon:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES");
            roleIcon:SetTexCoord(GetTexCoordsForRoleSmallCircle(role));
            roleIcon:Show();
            roleIcon:SetSize(10, 10);
        else
            roleIcon:Hide();
            roleIcon:SetSize(1, 1);
        end
    end
end
    
function MistWeaver_OnUpdate(self, elapsed) 
    if (not init) then
        return;
    end
    
    if (not active) then
        return;
    end

    local unitFrame;
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        local unit = unitFrame.unit;
        
        if (unit and UnitExists(unit)) then
            MistWeaver_UpdateUnit(unitFrame, unit);
        else
            unitFrame.art.dc:Hide();
        end
    end
    
    MistWeaver_UpdatePower();
    MistWeaver_UpdateDeBuffs();
end
    
function MistWeaver_UpdatePower()
    local chiBar = _G["MwPowerFrameChi"];
    local manaBar = _G["MwPowerFrameMana"];

    local chi = UnitPower("player", SPELL_POWER_LIGHT_FORCE);
    local chiMax = UnitPowerMax("player", SPELL_POWER_LIGHT_FORCE);
    
    chiBar:SetMinMaxValues(0, chiMax);
    chiBar:SetValue(chi);
    chiBar.text:SetText(chi.."/"..chiMax);

    -- mana
    local mana = UnitPower("player", SPELL_POWER_MANA);
    local manaMax = UnitPowerMax("player", SPELL_POWER_MANA);
    
    manaBar:SetMinMaxValues(0, manaMax);
    manaBar:SetValue(mana);
    manaBar.text:SetText(format("%.0f", (100 * mana / manaMax)).." %");
end
    
function MistWeaver_UpdateDeBuffs()
    local VITAL_MISTS_BUFF_ID = 118674;
    local MANATEA_BUFF_ID = 115867;
    local index = 1;
    
    local name, _, _, count, _, _, _, _, _, _, spellID = UnitBuff("player", index);
    
    MwSurgingMistCastFrame.button.count:SetText("");
    MwManaTeaFrame.button.count:SetText("");
    
    while name do 
        if (spellID == VITAL_MISTS_BUFF_ID) then
            if (count == 5) then
                MwSurgingMistCastFrame.button.count:SetText(SPELL_CAST_TIME_INSTANT_NO_MANA);
            else
                local percent = count * 20;
                MwSurgingMistCastFrame.button.count:SetText(format("%d", percent).." %");
            end
        end
        
        if (spellID == MANATEA_BUFF_ID) then
            MwManaTeaFrame.button.count:SetText(count);
        end
        
        index = index + 1;        
        name, _, _, count, _, _, _, _, _, _, spellID = UnitBuff("player", index);
    end
end
    
function MistWeaver_GetUnitFrameForUnit(unit)    
    local unitFrame;
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        
        if (unitFrame and unitFrame:IsVisible() and unitFrame.unit == unit) then
            return unitFrame;
        end
    end
    
    return nil;
end

function MistWeaver_UpdateHealPrediction()
    local unitFrame, unit;
    for i=1, 25, 1 do
        unitFrame = _G["MwUnitFrame"..i];
        unit = unitFrame.unit;
        
        if (unit) then
            MistWeaver_UpdateHealPredictionForUnit(frame, unit);
        end
    end
end    

local MAX_INCOMING_HEAL_OVERFLOW = 1.05;
function MistWeaver_UpdateHealPredictionForUnit(frame, unit)
    local unitFrame = MistWeaver_GetUnitFrameForUnit(unit);
    
    if (not unitFrame) then
        return;
    end
    
    local healthBar = _G[unitFrame:GetName().."Health"];
    local healthPredictionBar = _G[unitFrame:GetName().."HealthPrediction"];

    local allIncomingHeal = UnitGetIncomingHeals(unit) or 0;
    
    --Make sure we don't go too far out of the frame.
    local health = healthBar:GetValue();
    local _, maxHealth = healthBar:GetMinMaxValues();
    
    --See how far we're going over.
    if (health + allIncomingHeal > maxHealth * MAX_INCOMING_HEAL_OVERFLOW) then
        allIncomingHeal = maxHealth * MAX_INCOMING_HEAL_OVERFLOW - health;
    end
    
    healthPredictionBar:SetMinMaxValues(0, maxHealth);
    healthPredictionBar:SetValue(health + allIncomingHeal);
end
    
function MistWeaver_UpdateUnit(frame, unit)
    MistWeaver_UpdateUnitHighlight(frame);
    MistWeaver_UpdateUnitHealth(frame, unit);
    MistWeaver_UpdateRenewingMist(frame, unit);
    MistWeaver_UpdateUnitThreatSituation(frame, unit);
    MistWeaver_UpdateUnitState(frame, unit);
    MistWeaver_UpdateUnitDetox(frame, unit);
end

function MistWeaver_UpdateUnitHighlight(frame)

    local art = _G[frame:GetName().."Art"];
    
    if (frame.highlight) then
        art.highlight:Show();
        art.highlight:SetVertexColor(MistWeaverData.HIGHLIGHT_RED, MistWeaverData.HIGHLIGHT_GREEN, MistWeaverData.HIGHLIGHT_BLUE);        
    else
        art.highlight:Hide();
    end
end

function MistWeaver_UpdateUnitHealth(frame, unit)
    local healthBar = _G[frame:GetName().."Health"];
    
    local health = UnitHealth(unit);
    local healthMax = UnitHealthMax(unit);
    
    healthBar:SetMinMaxValues(0, healthMax);
    healthBar:SetValue(health);
    
    local localizedClass, englishClass = UnitClass(unit);
    local classColor = RAID_CLASS_COLORS[englishClass];
    
    if (not classColor) then
        classColor = { r = 1.0, g = 1.0, b = 1.0, colorStr = "ffffffff" };
    end
    
    if (MistWeaverData.COLORTYPE == 1) then
        local color = GREEN_FONT_COLOR;        

        local percent = 0;
        
        if (healthMax > 0) then
            percent = 100 * health / healthMax;
        end
        
        if (percent < 20) then
            color = RED_FONT_COLOR;  
        elseif (percent < 40) then 
            color = ORANGE_FONT_COLOR;  
        elseif (percent < 70) then
            color = YELLOW_FONT_COLOR;  
        end
    
        healthBar:SetStatusBarColor(color.r, color.g, color.b);     
        local hexColor = mw_rgb2hex(classColor.r, classColor.g, classColor.b);
        healthBar.text:SetText("|cff"..hexColor..GetUnitName(unit).."|r");
    else
        healthBar:SetStatusBarColor(classColor.r, classColor.g, classColor.b); 
        healthBar.text:SetText(GetUnitName(unit)); 
    end
end
    
function MistWeaver_UpdateRenewingMist(frame, unit)
    local renewingMistBar = _G[frame:GetName().."RenewingMist"];
    
    -- check buffs
    local name, rank, icon, count, debuffType, duration, expirationTime = UnitBuff(unit, RENEWING_MIST, "");
    
    if (name and name == RENEWING_MIST) then    
        local startTime = expirationTime - duration;
        renewingMistBar:SetMinMaxValues(0, expirationTime-startTime);
        renewingMistBar:SetValue(expirationTime-GetTime());
        return;
    else
        renewingMistBar:SetValue(0);
    end
end
    
function MistWeaver_UpdateUnitThreatSituation(frame, unit)    
    local isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation(unit, unit.."target");
    local r, g, b = GetThreatStatusColor(status);
    
    local aggroTexture = frame.art.aggro;
    if (status and status > 0) then
        aggroTexture:SetVertexColor(GetThreatStatusColor(status));
        aggroTexture:Show();
    else
        aggroTexture:Hide();
    end
end
    
function MistWeaver_UpdateUnitState(frame, unit)    
    local info = frame.art.info;
    local dc = frame.art.dc;
    
    local isAFK = UnitIsAFK(unit);
    local isDead = UnitIsDead(unit);
    local isInRange = UnitInRange(unit);
    local isConnected = UnitIsConnected(unit);
    
    if (unit == "player") then
        isInRange = 1;
    end
    
    if (isAFK or isDead or (not isInRange) or (not isConnected)) then
        MistWeaver_SetUnitFrameAlpha(frame, 0.3, 0.0);
        if (not isConnected) then
            info:SetText("");
            dc:Show();
        elseif (isAFK) then
            info:SetText(AFK);
            dc:Hide();
        elseif (isDead) then
            info:SetText(DEAD);
            dc:Hide();
        elseif (not isInRange) then
            info:SetText("");
            dc:Hide();
        end
    else
        MistWeaver_SetUnitFrameAlpha(frame, 1.0, 0.5);
        info:SetText("");
        dc:Hide();
    end
end

function MistWeaver_UpdateUnitDetox(frame, unit)
    local debuffName, debuffType;
    for index=1, 40 do
        debuffName, _, _, _, debuffType = UnitDebuff(unit, index);
        
        if (not debuffName) then
            break;
        end
        
        if (debuffType == "Magic" or debuffType == "Poison" or debuffType == "Disease") then
            frame.art.detox:Show();
            return;
        end
    end
    
    frame.art.detox:Hide();
end
    
function MistWeaver_SetUnitFrameAlpha(frame, alpha, alpha2)   
    _G[frame:GetName().."Health"]:SetAlpha(alpha); 
    _G[frame:GetName().."RenewingMist"]:SetAlpha(alpha); 
    _G[frame:GetName().."Backdrop"]:SetAlpha(alpha); 
    _G[frame:GetName().."HealthPrediction"]:SetAlpha(alpha2); 
end

